Angular Progress Component

Progress

Documentation and examples for using Angular progress bars featuring support for stacked bars, animated backgrounds, and text labels.

Available in Other JavaScript Frameworks

CoreUI Angular Progress Component is also available for Bootstrap, React, and Vue. Explore framework-specific implementations below:

Examples

Progress components are built with two HTML elements, some CSS to set the width, and a few attributes. We don’t use the HTML5 <progress> element, ensuring you can stack progress bars, animate them, and place text labels over them.

New markup in CoreUI v5

We’ve simplified the HTML structure for progress bars to improve accessibility while still maintaining backward compatibility with the previous structure.

Basic usage

import { Component } from '@angular/core';
import { ProgressComponent } from '@coreui/angular';

@Component({
  selector: 'docs-progress-example',
  templateUrl: './progress-example.component.html',
  imports: [ProgressComponent]
})
export class ProgressExampleComponent {}
<c-progress [value]="0" />
<c-progress [value]="25" />
<c-progress [value]="50" />
<c-progress [value]="75" />
<c-progress [value]="100" />

Labels

Add labels to your progress bars by placing text within the <c-progress>.

import { Component } from '@angular/core';
import { ProgressBarComponent, ProgressComponent } from '@coreui/angular';

@Component({
  selector: 'docs-progress-labels',
  templateUrl: './progress-labels.component.html',
  imports: [ProgressComponent, ProgressBarComponent]
})
export class ProgressLabelsComponent {}
<c-progress [value]="25">25%</c-progress>
<c-progress>
  <c-progress-bar [value]="10" class="overflow-visible text-dark px-2" color="success">
    Long label text for the progress bar, set it to a dark color...
  </c-progress-bar>
</c-progress>

Please take note that the default setting for the <c-progress> content is to be limited by the overflow: hidden property. This is done to prevent the content from extending beyond the progress bar’s boundaries. However, if the progress bar is shorter than its label, the content may be truncated and become difficult to read. To modify this behavior, you can use the .overflow-visible class from the overflow utilities. Just make sure to specify a specific text color to ensure readability. Do keep in mind that this approach does not consider color modes at the moment.

Height

We only set a height value on the <c-progress>, so if you change that value, the inner <c-progress-bar> will automatically resize accordingly.

import { Component } from '@angular/core';
import { ProgressComponent } from '@coreui/angular';

@Component({
  selector: 'docs-progress-height',
  templateUrl: './progress-height.component.html',
  imports: [ProgressComponent]
})
export class ProgressHeightComponent {}
<c-progress [height]="1" [value]="25" />
<c-progress [height]="5" [value]="25" />
<c-progress [height]="10" [value]="25" />
<c-progress [height]="15" [value]="25" />
<c-progress [height]="20" [value]="25" />

Backgrounds

Use color prop to change the appearance of individual progress bars.

It is important to choose an appropriate text color when incorporating labels into progress bars with a custom background color. This ensures readability and adequate contrast for the labels.

import { Component } from '@angular/core';
import { ProgressComponent } from '@coreui/angular';

@Component({
  selector: 'docs-progress-backgrounds',
  templateUrl: './progress-backgrounds.component.html',
  imports: [ProgressComponent]
})
export class ProgressBackgroundsComponent {}
<c-progress [value]="25" color="success">25%</c-progress>
<c-progress [value]="50" color="info" />
<c-progress [value]="75" color="warning">
  <span class="text-dark px-2">75%</span>
</c-progress>
<c-progress [value]="100" color="danger" />

Multiple bars

New markup in CoreUI v5

We added a new stacked component to group multiple progress bars into a single stacked progress bar.

Include multiple progress bars in a <c-progress-stacked> component to create a single stacked progress bar.

import { Component } from '@angular/core';
import { ProgressComponent, ProgressStackedComponent } from '@coreui/angular';

@Component({
  selector: 'docs-progress-multiple-bars',
  templateUrl: './progress-multiple-bars.component.html',
  imports: [ProgressComponent, ProgressStackedComponent]
})
export class ProgressMultipleBarsComponent {}
<c-progress-stacked>
  <c-progress [value]="15" />
  <c-progress [value]="30" color="success" />
  <c-progress [value]="20" color="info" />
</c-progress-stacked>

Striped

Add variant="striped" to any <c-progress> to apply a stripe via CSS gradient over the progress bar’s background color.

import { Component } from '@angular/core';
import { ProgressComponent } from '@coreui/angular';

@Component({
  selector: 'docs-progress-striped',
  templateUrl: './progress-striped.component.html',
  imports: [ProgressComponent]
})
export class ProgressStripedComponent {}
<c-progress [value]="25" color="success" variant="striped" />
<c-progress [value]="50" color="info" variant="striped" />
<c-progress [value]="75" color="warning" variant="striped" />
<c-progress [value]="100" color="danger" variant="striped" />

Animated stripes

The striped gradient can also be animated. Add animated property to <c-progress> to animate the stripes right to left via CSS3 animations.

import { Component } from '@angular/core';
import { ProgressComponent } from '@coreui/angular';

@Component({
  selector: 'docs-progress-animated-stripes',
  templateUrl: './progress-animated-stripes.component.html',
  imports: [ProgressComponent]
})
export class ProgressAnimatedStripesComponent {}
<c-progress [animated]="true" [value]="25" color="success" variant="striped" />
<c-progress [animated]="true" [value]="50" color="info" variant="striped" />
<c-progress [animated]="true" [value]="75" color="warning" variant="striped" />
<c-progress [animated]="true" [value]="100" color="danger" variant="striped" />

Thin

Thin variant of progress

import { Component } from '@angular/core';
import { ProgressComponent } from '@coreui/angular';

@Component({
  selector: 'docs-progress-thin',
  templateUrl: './progress-thin.component.html',
  imports: [ProgressComponent]
})
export class ProgressThinComponent {}
<c-progress [value]="25" color="primary" thin />
<c-progress [value]="25" color="secondary" thin />
<c-progress [value]="25" color="success" thin />
<c-progress [value]="25" color="danger" thin />
<c-progress [value]="25" color="warning" thin />
<c-progress [value]="25" color="info" thin />

Styling

Learn how to customize the Angular Progress component with CSS classes, variables, and SASS for flexible styling and seamless integration into your design.

CSS variables

Angular Progress supports CSS variables for easy customization. These variables are set via SASS but allow direct overrides in your stylesheets or inline styles.

How to use CSS variables

import { NgStyle } from '@angular/common';
import { Component } from '@angular/core';
import { ProgressComponent } from '@coreui/angular';

@Component({
  selector: 'docs-progress-css',
  imports: [NgStyle, ProgressComponent],
  templateUrl: './progress-css.component.html'
})
export class ProgressCssComponent {}
@let vars = {
  '--cui-progress-bg': 'var(--cui-success-bg-subtle)',
  '--cui-progress-bar-bg': 'mediumseagreen'
};

<c-progress [ngStyle]="vars" [value]="42" />

SASS variables

Accessibility

The Angular Progress component is built with accessibility in mind. Each progressbar includes the following ARIA attributes:

  • role: progressbar
  • aria-valuemin: Minimum value
  • aria-valuemax: Maximum value
  • aria-valuenow: Current value

API reference

Progress Module

Progress Standalone

c-progress

component

jsx
import { ProgressComponent } from '@coreui/angular'
PropertyDefaultType
animatedundefinedboolean

Use to animate the stripes right to left via CSS3 animations.

color-string

Sets the color context of the component to one of CoreUI’s themed colors.

height0number

Sets the height of the component. If you set that value the inner <c-progress-bar> will automatically resize accordingly.

max100number

The max value of the ProgressBar.

role'progressbar'string

Set default html role attribute.

thinfalseboolean

Displays thin progress.

value0number

The percent value the ProgressBar.

variantundefined'striped'

Set the progress bar variant to optional striped.

whitefalseboolean

Change the default color to white.

c-progress-bar

  • for backward compatibility
jsx
import { ProgressBarDirective } from '@coreui/angular'
PropertyDefaultType
animatedundefinedboolean

Use to animate the stripes right to left via CSS3 animations.

color-string

Sets the color context of the component to one of CoreUI’s themed colors.

max100number

The max value of the ProgressBar.

precision0number

Number of decimal places to round the computed percent value to.

role'progressbar'string

Set default html role attribute.

value0number

The percent value the ProgressBar.

variantundefined'striped'

Set the progress bar variant to optional striped.

# Vue Progress Component

> Documentation and examples for using Vue progress bars featuring support for stacked bars, animated backgrounds, and text labels.

## Example

Progress components are built with two HTML elements, some CSS to set the width, and a few attributes. We don't use [the HTML5 `<progress>` element](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/progress), ensuring you can stack progress bars, animate them, and place text labels over them.

## Basic usage

```html
<template>
  <CProgress :value="0" />
  <CProgress :value="25" />
  <CProgress :value="50" />
  <CProgress :value="75" />
  <CProgress :value="100" />
</template>

<script setup>
import { CProgress } from '@coreui/vue'
</script>
```
  
</Example>

## Labels

Add labels to your progress bars by placing text within the `<CProgressBar>`.

```html
<template>
  <CProgress :value="25">25%</CProgress>
</template>

<script setup>
import { CProgress } from '@coreui/vue'
</script>
```
  
</Example>

Please note that the default setting for the content within the `` is to be limited by the `overflow: hidden property`, preventing it from extending beyond the bar's boundaries. If the progress bar is shorter than its label, the content will be truncated and could be difficult to read. To modify this behavior, you can utilize the `.overflow-visible` class from the overflow utilities. However, it is important to specify a specific text color to ensure readability. It's worth noting that this approach currently does not consider color modes.

```html
<template>
  <CProgress :value="10" color="success">
    <CProgressBar class="overflow-visible text-dark px-2"
      >Long label text for the progress bar, set to a dark color</CProgressBar
    >
  </CProgress>
</template>

<script setup>
import { CProgress, CProgressBar } from '@coreui/vue'
</script>
```
  
</Example>

Since **v5.0.0** you can also use the `progressBarClassName` property directly on the `` component to achieve the same.

```vue
<CProgress progressBarClassName="overflow-visible text-dark px-2" color="success" :value="10">Long label text for the progress bar, set to a dark color</CProgress>
```

## Height

We only set a `height` value on the `<CProgress>`, so if you change that value the inner `<CProgressBar>` will automatically resize accordingly.

```html
<template>
  <CProgress :height="1" :value="25" />
  <CProgress :height="20" :value="25" />
</template>

<script setup>
import { CProgress } from '@coreui/vue'
</script>
```
  
</Example>

## Backgrounds

Use `color` prop to change the appearance of individual progress bars.

```html
<template>
  <CProgress color="success" :value="25" />
  <CProgress color="info" :value="50" />
  <CProgress color="warning" :value="75" />
  <CProgress color="danger" :value="100" />
</template>

<script setup>
import { CProgress } from '@coreui/vue'
</script>
```
  
</Example>

Ensure that when you incorporate labels into progress bars featuring a custom background color, you also select an appropriate text color to ensure readability and maintain adequate contrast for the labels.

```html
<template>
  <CProgress color="success" :value="25">
    <CProgressBar>25%</CProgressBar>
  </CProgress>
  <CProgress color="info" :value="50">
    <CProgressBar class="text-dark">50%</CProgressBar>
  </CProgress>
  <CProgress color="warning" :value="75">
    <CProgressBar class="text-dark">75%</CProgressBar>
  </CProgress>
  <CProgress color="danger" :value="100">
    <CProgressBar>100%</CProgressBar>
  </CProgress>
</template>

<script setup>
import { CProgress, CProgressBar } from '@coreui/vue'
</script>
```
  
</Example>

Since **v5.0.0** you can also use the `progressBarClassName` property directly on the `` component to achieve the same.

```vue
<CProgress color="success" :value="25">25%</CProgress>
<CProgress color="info" progressBarClassName="text-dark" :value="50">50%</CProgress>
<CProgress color="warning" progressBarClassName="text-dark" :value="75">75%</CProgress>
<CProgress color="danger" :value="100">100%</CProgress>
```

## Multiple bars

Include multiple progress bars in a progress component if you need.

> In version 5.0.0, we introduced a new &lt;CProgressStacked&gt; component to more logically wrap multiple progress bars into a single stacked progress bar. The previous structure will continue to work until the next major version.

**New markup**

```html
<template>
  <CProgressStacked>
    <CProgress :value="15" />
    <CProgress color="success" :value="30" />
    <CProgress color="info" :value="20" />
  </CProgressStacked>
</template>

<script setup>
import { CProgressStacked, CProgress } from '@coreui/vue'
</script>
```
  
</Example>

**Previous markup**
```vue
<CProgress>
  
  
  
</CProgress>
```

## Striped

Add `variant="striped"` to any `<CProgressBar>` to apply a stripe via CSS gradient over the progress bar's background color.

```html
<template>
  <CProgress color="success" variant="striped" :value="25" />
  <CProgress color="info" variant="striped" :value="50" />
  <CProgress color="warning" variant="striped" :value="75" />
  <CProgress color="danger" variant="striped" :value="100" />
</template>

<script setup>
import { CProgress } from '@coreui/vue'
</script>
```
  
</Example>

## Animated stripes

The striped gradient can also be animated. Add `animated` property to `<CProgressBar>` to animate the stripes right to left via CSS3 animations.

```html
<template>
  <CProgress color="success" variant="striped" animated :value="25" />
  <CProgress color="info" variant="striped" animated :value="50" />
  <CProgress color="warning" variant="striped" animated :value="75" />
  <CProgress color="danger" variant="striped" animated :value="100" />
</template>

<script setup>
import { CProgress } from '@coreui/vue'
</script>
```
  
</Example>


# React Progress Component

> Documentation and examples for using React progress bars featuring support for stacked bars, animated backgrounds, and text labels.

## Example

Progress components are built with two HTML elements, some CSS to set the width, and a few attributes. We don't use [the HTML5 `<progress>` element](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/progress), ensuring you can stack progress bars, animate them, and place text labels over them.

## Basic usage

```html
import React from 'react'
import { CProgress } from '@coreui/react'

export const ProgressExample = () => {
  return (
    <>
      <CProgress value={0} />
      <CProgress value={25} />
      <CProgress value={50} />
      <CProgress value={75} />
      <CProgress value={100} />
    </>
  )
}
```
  
</Example>

## Labels

Add labels to your progress bars by placing text within the `<CProgressBar>`.

```html
import React from 'react'
import { CProgress } from '@coreui/react'

export const ProgressLabelsExample = () => {
  return <CProgress value={25}>25%</CProgress>
}
```
  
</Example>

Please note that the default setting for the content within the `` is to be limited by the `overflow: hidden property`, preventing it from extending beyond the bar's boundaries. If the progress bar is shorter than its label, the content will be truncated and could be difficult to read. To modify this behavior, you can utilize the `.overflow-visible` class from the overflow utilities. However, it is important to specify a specific text color to ensure readability. It's worth noting that this approach currently does not consider color modes.

```html
import React from 'react'
import { CProgress, CProgressBar } from '@coreui/react'

export const ProgressLabels2Example = () => {
  return (
    <CProgress value={10}>
      <CProgressBar className="overflow-visible text-dark px-2" color="success">
        Long label text for the progress bar, set to a dark color
      </CProgressBar>
    </CProgress>
  )
}
```
  
</Example>

Since **v4.9.0** you can also use the `progressBarClassName` property directly on the `` component to achieve the same.

```jsx
<CProgress progressBarClassName="overflow-visible text-dark px-2" color="success" value={10}>Long label text for the progress bar, set to a dark color</CProgress>
```

## Height

We only set a `height` value on the `<CProgress>`, so if you change that value the inner `<CProgressBar>` will automatically resize accordingly.

```html
import React from 'react'
import { CProgress } from '@coreui/react'

export const ProgressHeightExample = () => {
  return (
    <>
      <CProgress height={1} value={25} />
      <CProgress height={20} value={25} />
    </>
  )
}
```
  
</Example>

```html
import React from 'react'
import { CProgress, CProgressBar } from '@coreui/react'

export const ProgressHeight2Example = () => {
  return (
    <>
      <CProgress height={1}>
        <CProgressBar value={25}></CProgressBar>
      </CProgress>
      <CProgress height={20}>
        <CProgressBar value={25}></CProgressBar>
      </CProgress>
    </>
  )
}
```
  
</Example>

## Backgrounds

Use `color` prop to change the appearance of individual progress bars.

```html
import React from 'react'
import { CProgress } from '@coreui/react'

export const ProgressBackgroundsExample = () => {
  return (
    <>
      <CProgress color="success" value={25} />
      <CProgress color="info" value={50} />
      <CProgress color="warning" value={75} />
      <CProgress color="danger" value={100} />
    </>
  )
}
```
  
</Example>

Ensure that when you incorporate labels into progress bars featuring a custom background color, you also select an appropriate text color to ensure readability and maintain adequate contrast for the labels.

```html
import React from 'react'
import { CProgress, CProgressBar } from '@coreui/react'

export const ProgressBackgrounds2Example = () => {
  return (
    <>
      <CProgress color="success" value={25}>
        <CProgressBar>25%</CProgressBar>
      </CProgress>
      <CProgress color="info" value={50}>
        <CProgressBar className="text-dark">50%</CProgressBar>
      </CProgress>
      <CProgress color="warning" value={75}>
        <CProgressBar className="text-dark">75%</CProgressBar>
      </CProgress>
      <CProgress color="danger" value={100}>
        <CProgressBar>100%</CProgressBar>
      </CProgress>
    </>
  )
}
```
  
</Example>

Since **v4.9.0** you can also use the `progressBarClassName` property directly on the `` component to achieve the same.

```jsx
<CProgress color="success" value={25}>25%</CProgress>
<CProgress color="info" progressBarClassName="text-dark" value={50}>50%</CProgress>
<CProgress color="warning" progressBarClassName="text-dark" value={75}>75%</CProgress>
<CProgress color="danger" value={100}>100%</CProgress>
```

## Multiple bars

Include multiple progress bars in a progress component if you need. In **v4.9.0**

> In version 4.9.0, we introduced a new `` component to more logically wrap multiple progress bars into a single stacked progress bar. The previous structure will continue to work until the next major version.

```html
import React from 'react'
import { CProgress, CProgressStacked } from '@coreui/react'

export const ProgressMultipleBarsExample = () => {
  return (
    <CProgressStacked>
      <CProgress value={15} />
      <CProgress color="success" value={30} />
      <CProgress color="info" value={20} />
    </CProgressStacked>
  )
}
```
  
</Example>

**Previous markup**
```jsx
<CProgress>
  
  
  
</CProgress>
```

## Striped

Add `variant="striped"` to any `<CProgressBar>` to apply a stripe via CSS gradient over the progress bar's background color.

```html
import React from 'react'
import { CProgress } from '@coreui/react'

export const ProgressStripedExample = () => {
  return (
    <>
      <CProgress color="success" variant="striped" value={25} />
      <CProgress color="info" variant="striped" value={50} />
      <CProgress color="warning" variant="striped" value={75} />
      <CProgress color="danger" variant="striped" value={100} />
    </>
  )
}
```
  
</Example>

## Animated stripes

The striped gradient can also be animated. Add `animated` property to `<CProgressBar>` to animate the stripes right to left via CSS3 animations.

```html
import React from 'react'
import { CProgress } from '@coreui/react'

export const ProgressAnimatedStripedExample = () => {
  return (
    <>
      <CProgress color="success" variant="striped" animated value={25} />
      <CProgress color="info" variant="striped" animated value={50} />
      <CProgress color="warning" variant="striped" animated value={75} />
      <CProgress color="danger" variant="striped" animated value={100} />
    </>
  )
}
```
  
</Example>

## API

Check out the documentation below for a comprehensive guide to all the props you can use with the components mentioned here.

- [&lt;CProgress /&gt;](./api/#cprogress)
- [&lt;CProgressBar /&gt;](./api/#cprogressbar)
